
REM Galactic v2.3
REM Public Domain 1997 Jim Vassilakos
REM San Bernardino, California
REM jimv@empirenet.com
REM Written in Microsoft QuickBasic version 4.5

DIM subname$(16, 2)
DIM world$(80)
DIM basalg$(2, 50, 2)
DIM basalgn(2)
DIM algncol(50)
DIM letimage(13, 44) AS INTEGER
DIM length(44)
DIM jump%(300, 5)
DIM subtxt%(16)
DIM colors$(15)
DIM uwpstat$(15): REM stat names
DIM uwpnum%(15): REM number of definitions per stat
DIM uwppos%(15, 3): REM positions (main & mod) & color
DIM uwpdef$(15, 40): REM value definitions
DIM uwpval%(15, 40, 2): REM low & high values for each def
DIM nhook%(2)
DIM hooke%(2, 15)
DIM hookac%(2, 15)
DIM hookcom$(2, 15)
DIM hookspec$(2, 15)
DIM hookvar$(8)
DIM hookval$(8)

ON ERROR GOTO 9900
RANDOMIZE INT(TIMER / 2)

DEF FNxstr$ (f21) = LTRIM$(STR$(f21))

DEF FNletter$ (f12)
   IF f12 <= 9 THEN f13$ = LTRIM$(STR$(f12))
   IF f12 >= 10 THEN f13$ = CHR$(f12 + 55)
   IF f12 >= 100 THEN f13$ = CHR$(f12 - 100)
   IF f12 >= 1000 THEN
      f13a = INT(f12 / 256)
      f13b = f12 - f13a
      f13$ = CHR$(f13a) + CHR$(f13b)
   END IF
   FNletter$ = f13$
END DEF

DEF FNnumber (f13$)
   f13$ = RTRIM$(LTRIM$(f13$))
   IF LEN(f13$) = 1 THEN
      SELECT CASE ASC(f13$)
         CASE 48 TO 57
            f12 = VAL(f13$)
         CASE 65 TO 90
            f12 = ASC(f13$) - 55
         CASE ELSE
            f12 = ASC(f13$) + 100
      END SELECT
   END IF
   IF LEN(f13$) = 2 THEN
      f13a$ = LEFT$(f13$, 1)
      f13b$ = RIGHT$(f13$, 1)
      f12 = (ASC(f13a$) * 256) + ASC(f13b$)
   END IF
   IF LEN(f13$) <> 1 AND LEN(f13$) <> 2 THEN
      f12 = 0
   END IF
   FNnumber = f12
END DEF

DEF FNuwp$ (f2)
f3len = 1
IF uwpval%(f2, 1, 1) > 1000 THEN f3len = 2
f3a$ = MID$(world$(ref), uwppos%(f2, 1), f3len)
IF f3a$ = "" OR f3a$ = "  " THEN f3a$ = " "
f8 = LEN(world$(ref))
IF uwppos%(f2, 2) <= f8 AND uwppos%(f2, 2) <> 0 THEN
   f3b$ = MID$(world$(ref), uwppos%(f2, 2), 1)
ELSE
   f3b$ = " "
END IF
f4a = FNnumber(f3a$)
f6$ = ""
FOR f5 = 1 TO uwpnum%(f2)
   IF f4a >= uwpval%(f2, f5, 1) AND f4a <= uwpval%(f2, f5, 2) THEN
      f6$ = uwpdef$(f2, f5)
   END IF
NEXT f5
IF f6$ = "" THEN f6$ = "Unknown"
IF f3a$ = " " THEN f6$ = "Empty"
IF f3b$ <> " " THEN
   f7 = INSTR(f6$, "?")
   f8 = LEN(f6$)
   IF f7 = 1 THEN f6$ = f3b$ + RIGHT$(f6$, f8 - 1)
   IF f7 > 1 AND f8 = f7 THEN f6$ = LEFT$(f6$, f8 - 1) + f3b$
   IF f7 > 1 AND f8 <> f7 THEN
      f6a$ = LEFT$(f6$, f7 - 1)
      f6b$ = RIGHT$(f6$, f8 - f7)
      f6$ = f6a$ + f3b$ + f6b$
   END IF
END IF
FNuwp$ = f6$
END DEF

DEF FNhook$ (f21$)
hookval$(1) = reader$
hookval$(2) = editor$
hookval$(3) = galdir$
hookval$(4) = secdir$
hookval$(5) = dir$ + secfile$
hookval$(6) = fsub$
hookval$(7) = sublet$
hookval$(8) = coord$
FOR f5 = 1 TO 8
   l = LEN(f21$)
   f22 = INSTR(f21$, hookvar$(f5))
   IF f22 > 0 THEN
      l2 = LEN(hookvar$(f5))
      f23$ = LEFT$(f21$, f22 - 1)
      f24$ = RIGHT$(f21$, l - f22 - l2 + 1)
      f21$ = f23$ + hookval$(f5) + f24$
   END IF
NEXT f5
FNhook$ = f21$
END DEF

fp1 = 1: fp2 = 1: fp3old = 7: fp4old = 3
FOR a = 1 TO 8: READ hookvar$(a): NEXT a

5 REM startover
GOSUB 5700: REM read configuration
GOSUB 5000: REM read letters.dat -> image data
GOSUB 5200: REM calculate video stuff
GOSUB 5450: REM read galaxy's uwp stats
GOSUB 5550: REM read names of 15 colors for insert jumproute query
GOSUB 5800: REM read hooks

10 REM front page
CLS : COLOR 14
PRINT "The Galactican's Guide to Known Space  (v2.3)"
PRINT "Public Domain 1997 Jim Vassilakos"
PRINT
COLOR 10: PRINT "Current Galaxy: "; galname$
LOCATE 4, 50: COLOR 13: PRINT "Editor: "; editor$
IF nosector = 1 THEN secname2$ = "<nil>"
COLOR 10: PRINT "Current Sector: "; secname2$
LOCATE 5, 50: COLOR 13: PRINT "Reader: "; reader$
PRINT : COLOR 11
PRINT "      About this Program         Star Maps"
PRINT
PRINT "      Read Galaxy Notes          Select Text Editor"
PRINT "      Edit Galaxy Notes          Select Text Reader"
PRINT
PRINT "      Read Sector Notes          Select/Create Galaxy"
PRINT "      Edit Sector Notes          Select/Create Sector"
PRINT
PRINT "      Quit"

14 REM arrow
LOCATE fp3old, fp4old
PRINT "  "
IF fp1 = 1 THEN fp3 = 7
IF fp1 = 2 THEN fp3 = 9
IF fp1 = 3 THEN fp3 = 10
IF fp1 = 4 THEN fp3 = 12
IF fp1 = 5 THEN fp3 = 13
IF fp1 = 6 THEN fp3 = 15
IF fp2 = 1 THEN fp4 = 3
IF fp2 = 2 THEN fp4 = 30
fp3old = fp3
fp4old = fp4
COLOR 12
LOCATE fp3, fp4
PRINT CHR$(196); CHR$(26)

15 REM get input
GOSUB 900
IF k2 = 0 AND (k1 >= 97 AND k1 <= 122) THEN k1 = k1 - 32
IF k2 = 0 AND k1 = 27 GOTO 10000: REM esc
IF k2 = 0 AND k1 = 81 GOTO 10000: REM Q 6,1
IF k2 = 1 AND (k1 = 75 OR k1 = 77) GOTO 16: REM left/right
IF k2 = 1 AND (k1 = 72 OR k1 = 80) GOTO 17: REM up/down
IF k2 = 1 AND (k1 = 73 OR k1 = 81) GOTO 17: REM pgup/pgdn
IF k2 = 0 AND k1 = 13 GOTO 18: REM enter
GOTO 15

16 REM left/right
IF fp1 = 6 GOTO 14
IF fp2 = 1 THEN fp2 = 3
IF fp2 = 2 THEN fp2 = 1
IF fp2 = 3 THEN fp2 = 2
SOUND 10000, .1
GOTO 14

17 REM up/down/pgup/pgdn
IF k1 = 72 THEN fp1 = fp1 - 1
IF k1 = 80 THEN fp1 = fp1 + 1
IF k1 = 73 THEN fp1 = 1
IF k1 = 81 THEN fp1 = 0
IF fp1 = 0 THEN fp1 = 7 - fp2
IF fp1 > 7 - fp2 THEN fp1 = 1
SOUND 10000, .1
GOTO 14

18 REM enter
IF fp1 = 1 AND fp2 = 1 GOTO 19
IF fp1 = 2 AND fp2 = 1 GOTO 26
IF fp1 = 3 AND fp2 = 1 GOTO 28
IF fp1 = 4 AND fp2 = 1 GOTO 22
IF fp1 = 5 AND fp2 = 1 GOTO 24
IF fp1 = 6 AND fp2 = 1 GOTO 10000
IF fp1 = 1 AND fp2 = 2 GOTO 40
IF fp1 > 1 AND fp2 = 2 GOTO 20

19 REM Help #1
GOSUB 5500: REM egacolor
SHELL "eg galhelp\galhelp.mnu " + reader$
GOTO 10

20 REM change settings
SHELL "galcfg " + CHR$(fp1 + 47)
GOTO 5

22 REM read sector notes
IF nosector = 1 GOTO 10
SHELL "eg " + gendir$ + "sector.mnu " + reader$
GOTO 10

24 REM edit sector notes
IF nosector = 1 GOTO 10
SHELL "eg " + gendir$ + "sector.mnu " + editor$
GOTO 10

26 REM read galaxy notes
SHELL "eg " + galdir$ + "\gen\galaxy.mnu " + reader$
GOTO 10

28 REM edit galaxy notes
SHELL "eg " + galdir$ + "\gen\galaxy.mnu " + editor$
GOTO 10

40 REM get sector data
IF nosector = 1 GOTO 10
GOSUB 2200

50 REM draw subsector boxes
SCREEN 0
COLOR 2
hhex = 101
trip = 1
CLS
LOCATE 1, 1: PRINT CHR$(201);
LOCATE 21, 61: PRINT CHR$(188);
LOCATE 1, 61: PRINT CHR$(187);
LOCATE 21, 1: PRINT CHR$(200);
FOR i = 16 TO 46 STEP 15
LOCATE 1, i: PRINT CHR$(203);
LOCATE 21, i: PRINT CHR$(202);
NEXT i
FOR i = 6 TO 16 STEP 5
LOCATE i, 1: PRINT CHR$(204);
LOCATE i, 61: PRINT CHR$(185);
NEXT i
FOR i = 16 TO 46 STEP 15
FOR j = 6 TO 16 STEP 5
LOCATE j, i: PRINT CHR$(206);
NEXT j
NEXT i
FOR i = 1 TO 46 STEP 15
FOR j = 1 TO 14
FOR k = 1 TO 21 STEP 5
LOCATE k, i + j: PRINT CHR$(205);
NEXT k
NEXT j
NEXT i
FOR i = 1 TO 16 STEP 5
FOR j = 1 TO 4
FOR k = 1 TO 61 STEP 15
LOCATE i + j, k: PRINT CHR$(186);
NEXT k
NEXT j
NEXT i

REM fill in subsector names
COLOR 14
FOR i = 1 TO 4
FOR j = 1 TO 4
k = j + ((i - 1) * 4)
lname = LEN(subname$(k, 1))
csubname$ = subname$(k, 1)
IF lname > 14 THEN csubname$ = LEFT$(subname$(k, 1), 14)
IF lname > 14 THEN lname = 14
LOCATE ((i - 1) * 5) + 3, ((j - 1) * 15) + 8 - INT((lname - 1) / 2)
PRINT csubname$;
NEXT j
NEXT i
LOCATE 23, 31 - INT(LEN(secname$) / 2)
PRINT secname$;
LOCATE 25, 70: COLOR 12: PRINT "? = Help";

60 REM make inner box and get instructions
tx = ((zj - 1) * 15) + 2
ty = ((zi - 1) * 5) + 2
COLOR 13
LOCATE ty, tx: PRINT CHR$(218);
LOCATE ty, tx + 13: PRINT CHR$(191);
LOCATE ty + 2, tx: PRINT CHR$(192);
LOCATE ty + 2, tx + 13: PRINT CHR$(217);
FOR i = tx + 1 TO tx + 12
LOCATE ty, i: PRINT CHR$(196);
LOCATE ty + 2, i: PRINT CHR$(196);
NEXT i
k = zj + ((zi - 1) * 4)
lname = LEN(subname$(k, 1))
IF lname < 13 THEN
   LOCATE ty + 1, tx
   PRINT CHR$(179);
END IF
IF lname < 14 THEN
   LOCATE ty + 1, tx + 13
   PRINT CHR$(179);
END IF
GOSUB 900
tx = ((zj - 1) * 15) + 2
ty = ((zi - 1) * 5) + 2
LOCATE ty, tx: PRINT CHR$(32);
LOCATE ty, tx + 13: PRINT CHR$(32);
LOCATE ty + 2, tx: PRINT CHR$(32);
LOCATE ty + 2, tx + 13: PRINT CHR$(32);
FOR i = tx + 1 TO tx + 12
LOCATE ty, i: PRINT CHR$(32);
LOCATE ty + 2, i: PRINT CHR$(32);
NEXT i
k = zj + ((zi - 1) * 4)
lname = LEN(subname$(k, 1))
IF lname < 13 THEN
   LOCATE ty + 1, tx
   PRINT CHR$(32);
END IF
IF lname < 14 THEN
   LOCATE ty + 1, tx + 13
   PRINT CHR$(32);
END IF
IF k2 = 0 AND (k1 >= 97 AND k1 <= 122) THEN k1 = k1 - 32
IF k2 = 1 AND k1 = 72 THEN GOSUB 65: REM up
IF k2 = 0 AND k1 = 75 THEN GOSUB 65: REM k
IF k2 = 1 AND k1 = 80 THEN GOSUB 70: REM down
IF k2 = 0 AND k1 = 74 THEN GOSUB 70: REM j
IF k2 = 1 AND k1 = 75 THEN GOSUB 75: REM left
IF k2 = 0 AND k1 = 72 THEN GOSUB 75: REM h
IF k2 = 1 AND k1 = 77 THEN GOSUB 80: REM right
IF k2 = 0 AND k1 = 76 THEN GOSUB 80: REM l
IF k2 = 1 AND k1 = 73 THEN zi = 1: REM pgup
IF k2 = 1 AND k1 = 81 THEN zi = 4: REM pgdn
IF k2 = 0 AND k1 = 9 THEN zj = 4: REM fwd tab
IF k2 = 1 AND k1 = 15 THEN zj = 1: REM back tab
IF k2 = 0 AND k1 = 27 THEN GOTO 10: REM esc
IF k2 = 0 AND k1 = 81 GOTO 10: REM q
IF k2 = 0 AND k1 = 13 THEN GOTO 90: REM enter
IF k2 = 0 AND k1 = 32 THEN GOTO 90: REM space
catch = 0: REM hook catching
FOR tmp = 1 TO nhook%(1)
   IF k2 = hooke%(1, tmp) AND k1 = hookac%(1, tmp) THEN catch = tmp
NEXT tmp
IF catch > 0 GOTO 62
GOTO 60

62 REM hook caught
zk = zj + ((zi - 1) * 4)
fsub$ = mapdir$ + subname$(zk, 2)
IF INSTR(hookspec$(1, catch), "E") > 0 THEN GOSUB 5500
SHELL FNhook$(hookcom$(1, catch))
IF INSTR(hookspec$(1, catch), "U") > 0 THEN GOSUB 5450
SCREEN 12: hhex = hex: trip = 1
GOTO 40

65 REM up
zi = zi - 1
IF zi = 0 THEN
   IF north$ = "<nil>" THEN zi = 1
   IF north$ <> "<nil>" THEN
      zi = 4: dir$ = north$: newjy = newjy + 4
      GOSUB 5710: GOTO 40
   END IF
END IF
RETURN

70 REM down
zi = zi + 1
IF zi = 5 THEN
   IF south$ = "<nil>" THEN zi = 4
   IF south$ <> "<nil>" THEN
      zi = 1: dir$ = south$: newjy = newjy - 4
      GOSUB 5710: GOTO 40
   END IF
END IF
RETURN

75 REM left
zj = zj - 1
IF zj = 0 THEN
   IF west$ = "<nil>" THEN zj = 1
   IF west$ <> "<nil>" THEN
      zj = 4: dir$ = west$: newjx = newjx + 4
      GOSUB 5710: GOTO 40
   END IF
END IF
RETURN

80 REM right
zj = zj + 1
IF zj = 5 THEN
   IF east$ = "<nil>" THEN zj = 4
   IF east$ <> "<nil>" THEN
      zj = 1: dir$ = east$: newjx = newjx - 4
      GOSUB 5710: GOTO 40
   END IF
END IF
RETURN

90 REM goto subsector screen
zk = zj + ((zi - 1) * 4)
fsub$ = mapdir$ + subname$(zk, 2)

100 REM get subsector
jumps = 0
FOR i = 1 TO 80
world$(i) = ""
NEXT i
OPEN "i", 1, fsub$
110 LINE INPUT #1, t4$
t4$ = LTRIM$(RTRIM$(t4$))
IF t4$ = "" GOTO 115
t3$ = LEFT$(t4$, 1)
IF (t3$ = "@" OR t3$ = "#") THEN GOTO 115
IF t3$ = "$" THEN
   jumps = jumps + 1
   rhex = VAL(MID$(t4$, 2, 4)): GOSUB 1100
   jump%(jumps, 1) = hex
   rhex = VAL(MID$(t4$, 7, 4)): GOSUB 1100
   jump%(jumps, 2) = hex
   jump%(jumps, 3) = VAL(MID$(t4$, 12, 2))
   place = 14
   IF jump%(jumps, 3) = -1 THEN place = place + 1
   jump%(jumps, 4) = VAL(MID$(t4$, place, 2))
   place = place + 2
   IF jump%(jumps, 4) = -1 THEN place = place + 1
   jump%(jumps, 5) = VAL(MID$(t4$, place, 2))
   IF jump%(jumps, 5) = 0 THEN jump%(jumps, 5) = 11
   GOTO 115
END IF
rhex = VAL(MID$(t4$, 15, 4))
GOSUB 1100
GOSUB 1150
world$(ref) = t4$
115 IF EOF(1) = -1 GOTO 120
GOTO 110
120 CLOSE 1

150 REM goto graphics mode
CLS
SCREEN 12

151 REM draw subsector map
CLS
REM draw blue hexs
COLOR 1
FOR a = 1 TO 8
FOR b = 1 TO 10
hex = (a * 100) + b
GOSUB 500
NEXT b
NEXT a
REM draw red hexs
COLOR 4
FOR a = 1 TO 8
FOR b = 1 TO 10
hex = (a * 100) + b
c = ((a - 1) * 10) + b
tmp$ = MID$(world$(c), 63, 1)
tmp2$ = MID$(world$(c), 64, 1)
IF LTRIM$(tmp$ + tmp2$) <> "" THEN GOSUB 500
NEXT b
NEXT a
REM draw jumproutes
IF jumps > 0 THEN
   FOR a = 1 TO jumps
      hex = jump%(a, 1): GOSUB 600
      p1 = cent1 + yank: p2 = cent2
      hex = jump%(a, 2): GOSUB 600
      p3 = cent1 + yank: p4 = cent2
      IF jump%(a, 3) <> 0 THEN
         p3 = p3 + (jump%(a, 3) * chexa * 12)
      END IF
      IF jump%(a, 4) <> 0 THEN
         p4 = p4 + (jump%(a, 4) * chexb * 20)
      END IF
      LINE (p1, p2)-(p3, p4), jump%(a, 5), , &H8888
   NEXT a
END IF
REM fill in map
FOR ref = 1 TO 80
IF LEN(world$(ref)) = 0 GOTO 155
l = ASC(MID$(world$(ref), 20, 1)) - 64
IF l = 24 THEN l = 6
GOSUB 1175
GOSUB 700
155 NEXT ref
REM subsector/sector name
COLOR 11
bottom$ = subname$(zk, 1) + "/" + secname$
l = LEN(bottom$)
LOCATE 29, 60 - INT(l / 2)
PRINT bottom$;

IF trip = 1 THEN
   hex = hhex
   trip = 0
END IF
GOSUB 800
GOTO 210
200 GOSUB 900
IF k2 = 0 AND (k1 >= 97 AND k1 <= 122) THEN k1 = k1 - 32
IF k2 = 1 AND k1 = 72 GOTO 1000: REM up
IF k2 = 0 AND k1 = 75 GOTO 1000: REM k
IF k2 = 1 AND (k1 = 73 OR k1 = 81) GOTO 1010: REM pgup/pgdn
IF k2 = 0 AND k1 = 9 GOTO 1010: REM fwd tab
IF k2 = 1 AND k1 = 15 GOTO 1010: REM back tab
IF k2 = 1 AND k1 = 80 GOTO 1020: REM down
IF k2 = 0 AND k1 = 74 GOTO 1020: REM j
IF k2 = 1 AND k1 = 75 GOTO 1040: REM left
IF k2 = 0 AND k1 = 72 GOTO 1040: REM h
IF k2 = 1 AND k1 = 77 GOTO 1060: REM right
IF k2 = 0 AND k1 = 76 GOTO 1060: REM l
IF k2 = 0 AND k1 = 27 GOTO 50: REM esc
IF k2 = 0 AND k1 = 81 GOTO 50: REM q
IF k2 = 0 AND k1 = 13 GOTO 2000: REM enter
IF k2 = 0 AND k1 = 32 GOTO 2000: REM space
IF k2 = 0 AND k1 = 62 GOTO 2000: REM >
IF k2 = 0 AND k1 = 85 GOTO 315: REM u
IF k2 = 0 AND k1 = 12 GOTO 290: REM ctrl-l
IF k2 = 1 AND (k1 = 59 OR k1 = 60) GOTO 330: REM F1/F2
IF k2 = 1 AND k1 = 62 GOTO 425: REM F4
IF k2 = 1 AND k1 = 64 GOTO 460: REM F6
IF k2 = 1 AND k1 = 66 GOTO 430: REM F8
IF k2 = 1 AND k1 = 83 GOTO 440: REM delete
catch = 0: REM hook catching
FOR tmp = 1 TO nhook%(2)
   IF k2 = hooke%(2, tmp) AND k1 = hookac%(2, tmp) THEN catch = tmp
NEXT tmp
IF catch > 0 GOTO 205
GOTO 210

205 REM hook caught
IF INSTR(hookspec$(2, catch), "1") > 0 AND world$(ref) = "" GOTO 200
IF INSTR(hookspec$(2, catch), "0") > 0 AND world$(ref) <> "" GOTO 200
IF INSTR(hookspec$(2, catch), "E") > 0 THEN
   SCREEN 0: GOSUB 5500
END IF
SHELL FNhook$(hookcom$(2, catch))
IF INSTR(hookspec$(2, catch), "U") > 0 THEN GOSUB 5450
SCREEN 12: hhex = hex: trip = 1
GOTO 100

210 GOSUB 1150: REM get ref#
COLOR 14
hw$ = MID$(world$(ref), 64, 1)
hidden$ = MID$(world$(ref), 65, 1)
hidden = 0: nonworld = 0: noname = 0
IF hidden$ = "h" THEN hidden = 1
IF hidden$ = "H" THEN hidden = 2
IF MID$(world$(ref), 20, 1) = "*" THEN nonworld = 1
IF RTRIM$(LEFT$(world$(ref), 14)) = "." THEN noname = 1
IF LEN(world$(ref)) = 0 OR (hidden = 2 AND nonworld = 1) THEN
   GOSUB 1200: REM empty hex
ELSE
   GOSUB 1250: REM non-empty hex
END IF
GOTO 200

290 REM redraw subsector
trip = 1: hhex = hex
GOTO 151

315 REM sector-level uwp.dat
tmp$ = dir$ + "uwp.dat"
OPEN "r", 1, tmp$
exist = LOF(1)
CLOSE 1
IF exist <> 0 GOTO 318
GOSUB 5640
316 GOSUB 900
IF k2 = 1 GOTO 316
IF k1 >= 97 AND k1 <= 122 THEN k1 = k1 - 32
IF k1 = 27 OR k1 = 81 OR k1 = 78 GOTO 290: REM esc/q/n
IF k1 = 89 GOTO 317: REM y
GOTO 316
317 SHELL "copy classic\beyond\uwp.dat " + tmp$
318 SCREEN 0
GOSUB 5500: REM egacolor
SHELL editor$ + " " + tmp$
GOSUB 5450: REM read uwp.dat
SCREEN 12: GOTO 290

330 REM view/edit subsector write-up
IF subtxt%(zk) = 0 AND k1 = 59 THEN GOTO 200
newfile = 0
IF k1 = 59 THEN app$ = reader$
IF k1 = 60 THEN app$ = editor$
txtsub$ = locdir$ + "sub-" + CHR$(zk + 64)
IF subtxt%(zk) <> 0 GOTO 350
newfile = 1
tmp$ = "subsector"
GOSUB 5600: REM mini-menu
335 GOSUB 900
IF k2 = 0 AND (k1 >= 97 AND k1 <= 122) THEN k1 = k1 - 32
IF k2 = 0 AND k1 = 70 GOTO 340: REM f
IF k2 = 0 AND k1 = 77 GOTO 345: REM m
IF k2 = 0 AND k1 = 27 GOTO 290: REM esc
IF k2 = 0 AND k1 = 81 GOTO 290: REM q
GOTO 335
340 subtxt%(zk) = 1: abv$ = "f"
GOTO 350
345 subtxt%(zk) = 2: abv$ = "m"
350 IF subtxt%(zk) = 1 THEN txtsub$ = txtsub$ + ".txt"
IF subtxt%(zk) = 2 THEN txtsub$ = txtsub$ + ".mnu"
SCREEN 0
GOSUB 5500: REM egacolor
IF subtxt%(zk) = 1 AND newfile = 0 THEN
   SHELL app$ + " " + txtsub$
END IF
IF subtxt%(zk) = 2 AND newfile = 0 THEN
   SHELL "eg " + txtsub$ + " " + app$
END IF
IF subtxt%(zk) = 1 AND newfile = 1 THEN
   GOSUB 400: REM insert abv$ into sector file
   REM set up initial subsector text file
   f$ = txtsub$
   REM check if file f$ exists
   OPEN "r", 1, f$
   exist = LOF(1)
   CLOSE 1
   IF exist = 0 THEN
      OPEN "o", 1, txtsub$
      tmp$ = subname$(zk, 1) + " Subsector"
      PRINT #1, ""
      PRINT #1, tmp$
      PRINT #1, STRING$(LEN(tmp$), "-")
      PRINT #1, ""
      CLOSE 1
   END IF: REM exist=0
   REM go into subsector text file
   SHELL app$ + " " + txtsub$
   GOTO 394
END IF
IF subtxt%(zk) = 2 AND newfile = 1 THEN
   GOSUB 400: REM insert abv$ into sector file
   REM set up initial subsector menu file
   f$ = txtsub$
   f1$ = "sub-" + CHR$(zk + 64)
   REM check if file f$ exists
   OPEN "r", 1, f$
   exist = LOF(1)
   CLOSE 1
   IF exist = 0 THEN
      SHELL "erase " + f$
      OPEN "o", 1, f$
      OPEN "i", 2, "galdata\starter2.mnu"
      PRINT #1, "@dir=" + locdir$
      PRINT #1, "@Light Yellow"
      PRINT #1, ""
      PRINT #1, "          ";
      PRINT #1, subname$(zk, 1) + " Subsector"
      tmpcount = 0
      DO UNTIL EOF(2)
         LINE INPUT #2, t$
         lstart = LEN(t$)
         IF lstart = 1 THEN t$ = ""
         IF lstart > 1 THEN t$ = RIGHT$(t$, lstart - 1)
         PRINT #1, t$;
         IF RIGHT$(t$, 1) = "@" THEN
            tmpcount = tmpcount + 1
            IF tmpcount = 1 THEN PRINT #1, f1$ + ".txt"
            IF tmpcount = 2 THEN PRINT #1, f1$ + "2.txt"
         ELSE
            PRINT #1, ""
         END IF: REM @
      LOOP
      CLOSE 1
      CLOSE 2
   END IF: REM exist=0
   REM go into subsector menu file
   SCREEN 0
   GOSUB 5500: REM egacolor
   SHELL "eg " + txtsub$ + " " + app$
END IF
394 SCREEN 12
GOTO 290

400 REM insert abv$ into sector file
f$ = dir$ + secfile$
SHELL "copy " + f$ + " sector.tmp"
OPEN "i", 1, "sector.tmp"
OPEN "o", 2, f$
FOR i = 1 TO 7
   LINE INPUT #1, t$
   PRINT #2, t$
NEXT i
FOR i = 1 TO 16
   LINE INPUT #1, t$
   l = LEN(t$)
   IF i = zk THEN
      IF l < 49 THEN t$ = t$ + STRING$(49 - l, " ") + abv$
      IF l >= 49 THEN t$ = LEFT$(t$, 49) + abv$
   END IF
   PRINT #2, t$
NEXT i
DO UNTIL EOF(1)
   LINE INPUT #1, t$
   PRINT #2, t$
LOOP
CLOSE 1
CLOSE 2
SHELL "erase sector.tmp"
RETURN

425 REM hexworld
IF world$(ref) = "" OR noname = 1 GOTO 200
IF hidden > 0 OR nonworld = 1 GOTO 200
tmp$ = hexdir$ + "p" + MID$(world$(ref), 15, 4)
tmp2$ = RTRIM$(LEFT$(world$(ref), 14))
IF hw$ <> "x" AND hw$ <> "z" THEN
   REM fix subsector file
   IF hw$ = "y" THEN newhw$ = "z" ELSE newhw$ = "x"
   CLS : COLOR 11: LOCATE 5
   PRINT "Creating a blank world..."
   SHELL "copy " + fsub$ + " galdata\tmpsub.dat"
   OPEN "i", 1, "galdata\tmpsub.dat"
   OPEN "o", 2, fsub$
   DO UNTIL EOF(1)
      LINE INPUT #1, tsub$
      IF world$(ref) = tsub$ THEN
         lline = LEN(tsub$)
         IF lline < 63 THEN
            tsub$ = tsub$ + SPACE$(63 - lline) + newhw$ + hidden$
         ELSE
            tsub$ = LEFT$(tsub$, 63) + newhw$ + hidden$
         END IF
      END IF
      PRINT #2, tsub$
   LOOP
   CLOSE 1
   CLOSE 2
   SHELL "erase galdata\tmpsub.dat"
END IF
SCREEN 0
SHELL "hexworld " + tmp$ + " " + tmp2$
SCREEN 12: hhex = hex: trip = 1
GOTO 100

430 REM sysmap
IF world$(ref) = "" OR noname = 1 GOTO 200
IF hidden > 0 OR nonworld = 1 GOTO 200
tmp$ = sysdir$ + "s" + MID$(world$(ref), 15, 4)
tmp2$ = RTRIM$(LEFT$(world$(ref), 14))
IF hw$ <> "y" AND hw$ <> "z" THEN
   REM fix subsector file
   IF hw$ = "x" THEN newhw$ = "z" ELSE newhw$ = "y"
   CLS : COLOR 11: LOCATE 5
   PRINT "Creating a star system..."
   SHELL "copy " + fsub$ + " galdata\tmpsub.dat"
   OPEN "i", 1, "galdata\tmpsub.dat"
   OPEN "o", 2, fsub$
   DO UNTIL EOF(1)
      LINE INPUT #1, tsub$
      IF world$(ref) = tsub$ THEN
         lline = LEN(tsub$)
         IF lline < 63 THEN
            tsub$ = tsub$ + SPACE$(63 - lline) + newhw$ + hidden$
         ELSE
            tsub$ = LEFT$(tsub$, 63) + newhw$ + hidden$
         END IF
      END IF
      PRINT #2, tsub$
   LOOP
   CLOSE 1
   CLOSE 2
   SHELL "erase galdata\tmpsub.dat"
END IF
SCREEN 0
SHELL "sysmap " + tmp$ + " " + tmp2$
SCREEN 12: hhex = hex: trip = 1
GOTO 100

440 REM delete world (or non-world)
IF LEN(world$(ref)) = 0 THEN GOTO 290
GOSUB 5620: REM insert star query
442 GOSUB 900
IF k2 = 0 AND (k1 >= 97 AND k1 <= 122) THEN k1 = k1 - 32
IF k2 = 0 AND k1 = 89 GOTO 445: REM y
IF k2 = 0 AND k1 = 78 GOTO 290: REM n
IF k2 = 0 AND k1 = 27 GOTO 290: REM esc
IF k2 = 0 AND k1 = 81 GOTO 290: REM q
GOTO 442
445 REM call insdel to delete star
SCREEN 0
SHELL "insdel (del) " + hh$ + " " + fsub$
SCREEN 12: hhex = hex: trip = 1
GOTO 100

460 REM insert jump route
IF newjump$ <> "" GOTO 465
newjump$ = MID$(world$(ref), 15, 4)
newjx = zj: newjy = zi: newjf$ = fsub$
GOTO 290
465 REM 1st world already selected
IF newjump$ <> MID$(world$(ref), 15, 4) GOTO 470
newjump$ = ""
GOTO 290
470 REM 1st & 2nd world different
IF ABS(zj - newjx) > 1 OR ABS(zi - newjy) > 1 GOTO 478
GOSUB 5650: REM get color
472 GOSUB 900
IF k2 = 0 AND (k1 >= 97 AND k1 <= 122) THEN k1 = k1 - 32
IF k2 = 0 AND k1 >= 65 AND k1 <= 79 GOTO 475: REM a-o
IF k2 = 0 AND k1 = 27 OR k1 = 81 GOTO 478: REM esc/q
GOTO 472
475 tmp1$ = LTRIM$(STR$(k1 - 64))
REM from 1st to 2nd
tmp2$ = "$" + newjump$ + " " + MID$(world$(ref), 15, 4)
tmp2$ = tmp2$ + " " + LTRIM$(STR$(zj - newjx))
tmp2$ = tmp2$ + " " + LTRIM$(STR$(zi - newjy))
tmp2$ = tmp2$ + " " + tmp1$
REM from 2nd to 1st
tmp3$ = "$" + MID$(world$(ref), 15, 4) + " " + newjump$
tmp3$ = tmp3$ + " " + LTRIM$(STR$(newjx - zj))
tmp3$ = tmp3$ + " " + LTRIM$(STR$(newjy - zi))
tmp3$ = tmp3$ + " " + tmp1$
tmpfile$ = newjf$: tmp4$ = tmp2$: GOSUB 480
IF ABS(zj - newjx) = 1 OR ABS(zi - newjy) = 1 THEN
   tmpfile$ = fsub$: tmp4$ = tmp3$: GOSUB 480
END IF
478 newjump$ = "": hhex = hex: trip = 1: GOTO 100
480 SHELL "copy " + tmpfile$ + " galdata\tmpsub.dat"
OPEN "i", 1, "galdata\tmpsub.dat"
OPEN "o", 2, tmpfile$
DO UNTIL EOF(1)
LINE INPUT #1, tmp$
IF LEFT$(tmp$, 10) = "#--------1" THEN PRINT #2, tmp4$
PRINT #2, tmp$
LOOP
CLOSE 1
CLOSE 2
SHELL "erase galdata\tmpsub.dat"
RETURN

500 REM plot a hex
GOSUB 600
REM known=> cent1, cent2
REM from one o'clock clockwise
tmp1 = cent1 + .5 * chexa + yank
tmp2 = cent2 - hexb
tmp3 = cent1 + chexa + yank
tmp4 = cent2
LINE (tmp1, tmp2)-(tmp3, tmp4)
LINE -STEP(-.5 * chexa, chexb)
LINE -STEP(-chexa, 0)
LINE -STEP(-.5 * chexa, -chexb)
LINE -STEP(.5 * chexa, -chexb)
LINE -STEP(chexa, 0)
RETURN

600 REM find center point of hex
REM in=> hex
REM out=> cent1, cent2
cent1 = hexa
cent2 = hexb
thex = hex - 101
610 IF thex < 99 GOTO 620
REM going across
cent1 = cent1 + 1.5 * hexa
thex = thex - 100
GOTO 610
620 IF thex = 0 GOTO 630
REM going down
cent2 = cent2 + 2 * hexb
thex = thex - 1
GOTO 620
630 REM correct for even columns
IF INT(hex / 100) MOD 2 = 1 THEN GOTO 640
cent2 = cent2 + hexb
640 REM correct for screen aspect ratio
cent1 = cent1 * scar
RETURN

700 REM plot starport
IF LEN(world$(ref)) = 0 THEN RETURN
tmp3$ = MID$(world$(ref), 65, 1)
tmp4 = 0: tmp5 = 0: noname = 0
IF tmp3$ = "h" THEN tmp4 = 1
IF tmp3$ = "H" THEN tmp4 = 2
IF RTRIM$(LEFT$(world$(ref), 14)) = "." THEN noname = 1
IF MID$(world$(ref), 20, 1) = "*" THEN
   tmp5 = VAL(MID$(world$(ref), 21, 1))
END IF
GOSUB 600: REM centerpoint
REM find allegiance
s$ = MID$(world$(ref), 56, 2)
FOR i2 = 1 TO basalgn(2)
   IF s$ = basalg$(2, i2, 1) THEN all = algncol(i2)
NEXT i2
REM draw marker
REM asteroids or circle
IF tmp5 = 0 THEN
   s$ = MID$(world$(ref), 21, 1)
   IF (s$ = "R" OR s$ = "0") AND tmp4 = 0 THEN
      x = cent1 + yank: y = cent2
      COLOR all
      PSET (x, y): PSET (x + 2, y + 2): PSET (x - 2, y - 2)
      PSET (x + 2, y - 2): PSET (x - 2, y + 2)
   ELSE
      PSET (cent1 + yank, cent2), 0
      CIRCLE (cent1 + yank, cent2), 3, all
      REM fill circle if there's any water
      IF MID$(world$(ref), 23, 1) <> "0" OR tmp4 <> 0 THEN
         PAINT (cent1 + yank, cent2), all
      END IF
   END IF
   REM gas giant & bases marker
   IF tmp4 = 0 THEN
      IF MID$(world$(ref), 54, 1) <> "0" THEN
         CIRCLE (cent1 + yank + 8, cent2 - 4), 1, all
         PSET (cent1 + yank + 8, cent2 - 4), all
      END IF
      IF MID$(world$(ref), 31, 1) <> " " THEN
         CIRCLE (cent1 + yank - 8, cent2 - 4), 1, all
         PSET (cent1 + yank - 8, cent2 - 4), all
      END IF
   END IF
END IF
REM nonworld markers
REM triangle
IF tmp5 = 1 AND tmp4 < 2 THEN
   x = cent1 + yank: y = cent2
   PSET (x, y), 0
   LINE (x, y - 2)-(x + 2, y + 2), all
   LINE -STEP(-4, 0), all
   LINE -STEP(2, -4), all
   PAINT (x, y), all
END IF
REM square
IF tmp5 = 2 AND tmp4 < 2 THEN
   x = cent1 + yank: y = cent2
   PSET (x, y), 0
   LINE (x - 2, y - 2)-(x + 2, y + 2), all, B
   PAINT (x, y), all
END IF
REM diamond
IF tmp5 = 3 AND tmp4 < 2 THEN
   x = cent1 + yank: y = cent2
   PSET (x, y), 0
   LINE (x, y - 2)-(x + 2, y), all
   LINE -STEP(-2, 2), all
   LINE -STEP(-2, -2), all
   LINE -STEP(2, -2), all
   PAINT (x, y), all
END IF
REM lotsadots
IF tmp5 = 4 AND tmp4 < 2 THEN
   x = cent1 + yank: y = cent2
   COLOR all
   FOR x2 = -16 TO 16 STEP 4
      FOR y2 = -16 TO 16 STEP 4
         IF ABS(x2 * y2) < 192 THEN PSET (x + x2, y + y2)
      NEXT y2
   NEXT x2
END IF
REM zone
IF tmp4 < 2 OR tmp5 = 0 THEN
   s$ = MID$(world$(ref), 49, 1)
   IF s$ = "A" THEN
   CIRCLE (cent1 + yank, cent2), (hexa / 2) + 1, 14
   END IF
   IF s$ = "R" THEN
   CIRCLE (cent1 + yank, cent2), (hexa / 2) + 1, 12
   END IF
   IF s$ = "B" THEN
   CIRCLE (cent1 + yank, cent2), (hexa / 2) + 1, 11
   END IF
END IF
REM newjump circle
IF newjump$ = MID$(world$(ref), 15, 4) AND newjf$ = fsub$ THEN
   CIRCLE (cent1 + yank, cent2), (hexa / 2), 5
   CIRCLE (cent1 + yank, cent2), (hexa / 2) + 4, 5
END IF
REM write name
word$ = RTRIM$(LEFT$(world$(ref), 14))
lenword = LEN(word$)
x = cent1 + yank - (lenword * 3) + 1
y = cent2 + 10
IF tmp4 < 2 AND noname = 0 THEN GOSUB 5100
REM write starport
word$ = MID$(world$(ref), 20, 1)
x = cent1 + yank - 2: y = cent2 - 5
IF tmp4 = 0 AND word$ <> "*" THEN GOSUB 5100
RETURN

800 REM make circle
GOSUB 600
CIRCLE (cent1 + yank, cent2), hexa / 2, 13
RETURN

850 REM erase circle
GOSUB 600
CIRCLE (cent1 + yank, cent2), hexa / 2, 0
GOSUB 700
RETURN

900 REM get character from keyboard
k1 = 0: k2 = 0
910 k$ = INKEY$
IF k$ = "" THEN GOTO 910
k1 = ASC(k$)
IF k1 <> 0 THEN RETURN
k1 = ASC(RIGHT$(k$, 1))
k2 = 1
RETURN

1000 REM up
GOSUB 850
hex = hex - 1
IF RIGHT$(STR$(hex), 1) = "0" THEN GOTO 1002
GOSUB 800
GOTO 210
1002 IF zi <> 1 GOTO 1004
IF north$ <> "<nil>" THEN
   zi = 4: hhex = hex + 10: dir$ = north$: newjy = newjy + 4
   GOSUB 5710: GOSUB 2200
   trip = 1: GOTO 90
END IF
hex = hex + 1
GOSUB 800
GOTO 210
1004 zi = zi - 1
hhex = hex + 10
trip = 1
GOTO 90

1010 REM pgup/pgdn
GOSUB 850
IF k1 = 73 THEN hex = hex - ((hex - 1) MOD 10)
IF k1 = 81 THEN hex = hex + (9 - (hex - 1) MOD 10)
tmp1 = INT(hex / 100)
IF k1 = 15 THEN hex = (hex MOD 100) + (tmp1 - ((tmp1 - 1) MOD 8)) * 100
IF k1 = 9 THEN hex = (hex MOD 100) + (tmp1 + (7 - (tmp1 - 1) MOD 8)) * 100
GOSUB 800
GOTO 210

1020 REM down
GOSUB 850
hex = hex + 1
IF RIGHT$(STR$(hex), 1) = "1" THEN GOTO 1022
GOSUB 800
GOTO 210
1022 IF zi <> 4 THEN GOTO 1024
IF south$ <> "<nil>" THEN
   zi = 1: hhex = hex - 10: dir$ = south$: newjy = newjy - 4
   GOSUB 5710: GOSUB 2200
   trip = 1: GOTO 90
END IF
hex = hex - 1
GOSUB 800
GOTO 210
1024 zi = zi + 1
hhex = hex - 10
trip = 1
GOTO 90

1040 REM left
GOSUB 850
hex = hex - 100
IF hex < 100 THEN GOTO 1042
GOSUB 800
GOTO 210
1042 IF zj <> 1 THEN GOTO 1044
IF west$ <> "<nil>" THEN
   zj = 4: hhex = hex + 800: dir$ = west$: newjx = newjx + 4
   GOSUB 5710: GOSUB 2200
   trip = 1: GOTO 90
END IF
hex = hex + 100
GOSUB 800
GOTO 210
1044 zj = zj - 1
hhex = hex + 800
trip = 1
GOTO 90

1060 REM right
GOSUB 850
hex = hex + 100
IF hex > 900 THEN GOTO 1062
GOSUB 800
GOTO 210
1062 IF zj <> 4 THEN GOTO 1064
IF east$ <> "<nil>" THEN
   zj = 1: hhex = hex - 800: dir$ = east$: newjx = newjx - 4
   GOSUB 5710: GOSUB 2200
   trip = 1: GOTO 90
END IF
hex = hex - 100
GOSUB 800
GOTO 210
1064 zj = zj + 1
hhex = hex - 800
trip = 1
GOTO 90

1100 REM convert real hex to map hex
REM in -> rhex
REM out -> hex
t1 = INT(rhex / 100)
t2 = rhex - t1 * 100
1105 IF t1 <= 8 THEN GOTO 1110
t1 = t1 - 8
GOTO 1105
1110 IF t2 <= 10 THEN GOTO 1115
t2 = t2 - 10
GOTO 1110
1115 hex = t1 * 100 + t2
RETURN

1150 REM convert map hex to ref#
REM in -> hex
REM out -> ref
t1 = INT(hex / 100)
t2 = hex - t1 * 100
ref = (t1 - 1) * 10 + t2
RETURN

1175 REM convert ref# to map hex
REM in -> ref
REM out -> hex
t1 = INT((ref + 9) / 10)
t2 = ref MOD 10
IF t2 = 0 THEN t2 = 10
hex = t1 * 100 + t2
RETURN

1180 REM clear text half
LOCATE 1, 1
FOR t5 = 1 TO 28
PRINT SPACE$(35)
NEXT t5
REM draw little sector box
lsb1 = 10
lsb2 = 50
lsb3 = 260
lsb4 = 300
FOR i = lsb1 TO lsb2 STEP (lsb2 - lsb1) / 4
LINE (lsb3, i)-(lsb4, i), 1
NEXT i
FOR i = lsb3 TO lsb4 STEP (lsb4 - lsb3) / 4
LINE (i, lsb1)-(i, lsb2), 1
NEXT i
lsb5 = lsb1 + ((zi - 1) * ((lsb2 - lsb1) / 4))
lsb6 = lsb5 + ((lsb2 - lsb1) / 4)
lsb7 = lsb3 + ((zj - 1) * ((lsb4 - lsb3) / 4))
lsb8 = lsb7 + ((lsb4 - lsb3) / 4)
LINE (lsb7, lsb5)-(lsb8, lsb6), 12
LINE (lsb7, lsb6)-(lsb8, lsb5), 12
LOCATE 1, 1
RETURN

1200 REM empty hex
GOSUB 1180
PRINT "Empty Parsec"
REM PRINT "Subsector: "; subname$(zk, 1)
REM PRINT "Sector: "; secname$
tmphex = hex: GOSUB 1175
h$ = FNxstr$(hex)
h$ = "0" + h$
h1 = VAL(LEFT$(h$, 2))
h2 = VAL(RIGHT$(h$, 2))
h1 = h1 + (zj - 1) * 8
h2 = h2 + (zi - 1) * 10
sublet$ = CHR$(zk + 64)
h$ = sublet$ + h$
hh$ = FNxstr$(h1 * 100 + h2)
IF LEN(hh$) = 3 THEN hh$ = "0" + hh$
PRINT "Coordinates: "; hh$; " ("; h$; ")"
coord$ = hh$
hex = tmphex
GOTO 1255

1250 REM non-empty hex
GOSUB 1180
IF noname = 0 THEN
   IF hidden < 2 THEN
      IF nonworld = 0 THEN PRINT "World: ";
      PRINT RTRIM$(LEFT$(world$(ref), 14))
   ELSE
      IF nonworld = 0 THEN PRINT "World: ";
      PRINT "Unknown"
   END IF
END IF
REM PRINT "Subsector: "; subname$(zk, 1)
REM PRINT "Sector: "; secname$
hh$ = MID$(world$(ref), 15, 4)
coord$ = hh$
PRINT "Coordinates: "; hh$;
sublet$ = CHR$(zk + 64)
PRINT " (" + sublet$ + "0" + RIGHT$(STR$(hex), 3) + ")"

IF hidden > 0 THEN
   PRINT
   COLOR 11
   IF nonworld = 0 THEN PRINT "World Statistics Unknown"
END IF

IF hidden > 0 THEN GOTO 1255

IF nonworld = 1 THEN
   tmp$ = RTRIM$(MID$(world$(ref), 23, 25))
   IF tmp$ <> "" THEN
      PRINT : PRINT tmp$
   END IF
END IF
IF nonworld = 1 THEN GOTO 1255

REM PRINT "UWP: "; MID$(world$(ref), 20, 9);
REM extra$ = MID$(world$(ref), 59, 3)
REM IF LTRIM$(extra$) <> "" THEN
REM PRINT "-"; extra$
REM ELSE
REM PRINT
REM END IF

PRINT
FOR tmp = 1 TO numstats
   uwptmp$ = FNuwp$(tmp)
   IF uwptmp$ <> "Empty" THEN
      IF uwppos%(tmp, 3) = 0 THEN
         COLOR 11
      ELSE
         COLOR uwppos%(tmp, 3)
      END IF
      PRINT uwpstat$(tmp); ": "; uwptmp$
   END IF
NEXT tmp
PRINT : COLOR 10
GOSUB 1620: PRINT basalg$(2, 0, 0); " "; s1$
GOSUB 1590: PRINT basalg$(1, 0, 0); " "; s1$
GOSUB 1595: PRINT "Trade Codes: "; s1$
GOSUB 1610: PRINT "Travel Zone: "; s1$
1255 tmp$ = MID$(world$(ref), 63, 1)
PRINT
IF (tmp$ = "f" OR tmp$ = "m") AND noname = 0 THEN
   COLOR 13
   IF nonworld = 0 THEN PRINT "<Enter> = World Description"
   IF nonworld = 1 THEN PRINT "<Enter> = Site Description"
END IF
IF subtxt%(zk) <> 0 THEN
   COLOR 13: PRINT "F1 = Subsector Description"
END IF
IF (hw$ = "x" OR hw$ = "z") AND hidden = 0 THEN
   COLOR 13: PRINT "F4 = World Map"
END IF
IF (hw$ = "y" OR hw$ = "z") AND hidden = 0 THEN
   COLOR 13: PRINT "F8 = Star System Map"
END IF
COLOR 13: PRINT "? = Help";
RETURN

1590 REM bases
s$ = MID$(world$(ref), 31, 1)
FOR m = 1 TO basalgn(1)
IF s$ = basalg$(1, m, 1) THEN s1$ = basalg$(1, m, 2)
NEXT m
RETURN

1595 REM trade codes
IF MID$(world$(ref), 33, 1) = " " THEN
   s1$ = "None"
ELSE
   s1$ = MID$(world$(ref), 33, 16)
END IF
RETURN

1600 REM convert letter to number
REM in -> s$
REM out -> s
IF ASC(s$) >= 48 AND ASC(s$) <= 57 THEN s = VAL(s$)
IF ASC(s$) >= 65 AND ASC(s$) <= 90 THEN s = ASC(s$) - 55
RETURN

1610 REM zone
s$ = MID$(world$(ref), 49, 1)
IF s$ = " " OR s$ = "G" THEN s1$ = "Green"
IF s$ = "A" THEN s1$ = "Amber"
IF s$ = "R" THEN s1$ = "Red"
IF s$ = "B" THEN s1$ = "Blue"
RETURN

1620 REM allegiance
s$ = MID$(world$(ref), 56, 2)
FOR m = 1 TO basalgn(2)
IF s$ = basalg$(2, m, 1) THEN s1$ = basalg$(2, m, 2)
NEXT m
RETURN

2000 REM more information
IF world$(ref) = "" OR hidden > 0 OR noname = 1 THEN GOTO 200
ss$ = MID$(world$(ref), 63, 1)
app$ = reader$
IF k1 = 62 THEN app$ = editor$
IF ss$ <> "f" AND ss$ <> "m" THEN
 tmp$ = "star system"
 GOSUB 5600: REM mini-menu
2010 GOSUB 900
 IF k2 = 0 AND (k1 >= 97 AND k1 <= 122) THEN k1 = k1 - 32
 IF k2 = 0 AND k1 = 70 GOTO 2020: REM f
 IF k2 = 0 AND k1 = 77 GOTO 2020: REM m
 IF k2 = 0 AND k1 = 27 GOTO 2040: REM esc
 IF k2 = 0 AND k1 = 81 GOTO 2040: REM q
 GOTO 2010
2020 REM attach file/menu
 IF k1 = 70 THEN ss$ = "f"
 IF k1 = 77 THEN ss$ = "m"
 REM fix subsector file
 SHELL "copy " + fsub$ + " galdata\tmpsub.dat"
 OPEN "i", 1, "galdata\tmpsub.dat"
 OPEN "o", 2, fsub$
 DO UNTIL EOF(1)
  LINE INPUT #1, tsub$
  IF world$(ref) = tsub$ THEN
   lline = LEN(tsub$)
   IF lline < 62 THEN
    tsub$ = tsub$ + SPACE$(62 - lline) + ss$ + hw$ + hidden$
   ELSE
    tsub$ = LEFT$(tsub$, 62) + ss$ + hw$ + hidden$
   END IF
  END IF
  PRINT #2, tsub$
 LOOP
 CLOSE 1
 CLOSE 2
 SHELL "erase galdata\tmpsub.dat"
 app$ = editor$: trip2 = 1
 IF ss$ = "m" THEN
  f$ = locdir$ + "p" + MID$(world$(ref), 15, 4) + ".mnu"
  f1$ = "p" + MID$(world$(ref), 15, 4)
  REM check if file f$ exists
  OPEN "r", 1, f$
  exist = LOF(1)
  CLOSE 1
  IF exist = 0 THEN
   SHELL "erase " + f$
   OPEN "o", 1, f$
   OPEN "i", 2, "galdata\starter.mnu"
   PRINT #1, "@dir=" + locdir$
   PRINT #1, "@Light Yellow"
   PRINT #1, ""
   PRINT #1, "          ";
   PRINT #1, RTRIM$(LEFT$(world$(ref), 14)) + " " + "System"
   tmpcount = 0
   DO UNTIL EOF(2)
    LINE INPUT #2, t$
    lstart = LEN(t$)
    IF lstart = 1 THEN t$ = ""
    IF lstart > 1 THEN t$ = RIGHT$(t$, lstart - 1)
    PRINT #1, t$;
    IF RIGHT$(t$, 1) = "@" THEN
     tmpcount = tmpcount + 1
     IF tmpcount = 1 THEN PRINT #1, f1$ + ".txt"
     IF tmpcount = 2 THEN PRINT #1, f1$ + "b.txt"
     ELSE
     PRINT #1, ""
    END IF: REM @
   LOOP
   CLOSE 1
   CLOSE 2
  END IF: REM exist=0
 END IF: REM ss$="m"
 REM write system stats to text file if file doesn't already exist
 REM check if file f$ exists
 f$ = locdir$ + "p" + MID$(world$(ref), 15, 4) + ".txt"
 OPEN "r", 1, f$
 exist = LOF(1)
 CLOSE 1
 IF exist = 0 THEN
  SHELL "erase " + f$
  OPEN "o", 1, f$
  IF nonworld = 0 THEN PRINT #1, "World: ";
  PRINT #1, RTRIM$(LEFT$(world$(ref), 14))
  PRINT #1, "Subsector: "; subname$(zk, 1)
  PRINT #1, "Sector: "; secname$
  PRINT #1, "Coordinates: "; MID$(world$(ref), 15, 4);
  PRINT #1, " (" + CHR$(zk + 64) + "0" + RIGHT$(STR$(hex), 3) + ")"
  IF nonworld = 0 THEN
     PRINT #1, "UWP: "; MID$(world$(ref), 20, 9);
     extra$ = MID$(world$(ref), 59, 3)
     IF LTRIM$(extra$) <> "" THEN
        PRINT #1, "-"; extra$
     ELSE
        PRINT #1, ""
     END IF
  END IF
  PRINT #1, ""
  IF nonworld = 1 THEN
     tmp$ = RTRIM$(MID$(world$(ref), 23, 25))
     IF tmp$ <> "" THEN PRINT #1, tmp$
  ELSE
     FOR tmp = 1 TO numstats
      uwptmp$ = FNuwp$(tmp)
      IF uwptmp$ <> "Empty" THEN
       PRINT #1, uwpstat$(tmp); ": "; uwptmp$
      END IF
     NEXT tmp
     PRINT #1, ""
     GOSUB 1620: PRINT #1, basalg$(2, 0, 0); " "; s1$
     GOSUB 1590: PRINT #1, basalg$(1, 0, 0); " "; s1$
     GOSUB 1595: PRINT #1, "Trade Codes: "; s1$
     GOSUB 1610: PRINT #1, "Travel Zone: "; s1$
  END IF
  CLOSE 1
 END IF: REM exist=0
END IF: REM ss$ <> ...
REM *** end if block ***
SCREEN 0
f$ = locdir$ + "p" + MID$(world$(ref), 15, 4)
IF ss$ = "f" THEN f$ = f$ + ".txt"
IF ss$ = "m" THEN f$ = f$ + ".mnu"
GOSUB 5500: REM egacolor
IF ss$ = "f" THEN SHELL app$ + " " + f$
IF ss$ = "m" THEN SHELL "eg " + f$ + " " + app$
SCREEN 12
2040 hhex = hex: trip = 1
IF trip2 = 1 THEN
   trip2 = 0
   GOTO 100
END IF
GOTO 150

2200 REM get sector data
f$ = dir$ + secfile$
OPEN "i", 1, f$
LINE INPUT #1, secname$
LINE INPUT #1, temp$
LINE INPUT #1, north$
north$ = RIGHT$(north$, LEN(north$) - 3)
LINE INPUT #1, south$
south$ = RIGHT$(south$, LEN(south$) - 3)
LINE INPUT #1, east$
east$ = RIGHT$(east$, LEN(east$) - 3)
LINE INPUT #1, west$
west$ = RIGHT$(west$, LEN(west$) - 3)
LINE INPUT #1, temp$
FOR i = 1 TO 16
LINE INPUT #1, temp$
t9 = LEN(temp$)
subtxt%(i) = 0
IF MID$(temp$, 50, 1) = "f" THEN subtxt%(i) = 1
IF MID$(temp$, 50, 1) = "m" THEN subtxt%(i) = 2
subname$(i, 1) = RTRIM$(MID$(temp$, 4, 26))
subname$(i, 2) = RTRIM$(MID$(temp$, 30, 12))
NEXT i
j = 1
LINE INPUT #1, temp$
44 REM get base & status info
i = 0
LINE INPUT #1, basalg$(j, i, 0)
i = 1
45 IF EOF(1) = -1 THEN GOTO 46
LINE INPUT #1, temp$
IF temp$ = "" THEN GOTO 46
t9 = LEN(temp$)
IF j = 1 THEN
   basalg$(1, i, 1) = LEFT$(temp$, 1)
   basalg$(1, i, 2) = RTRIM$(RIGHT$(temp$, t9 - 4))
END IF
IF j = 2 THEN
   algncol(i) = VAL(LEFT$(temp$, 2))
   basalg$(2, i, 1) = MID$(temp$, 4, 2)
   basalg$(2, i, 2) = RTRIM$(RIGHT$(temp$, t9 - 8))
END IF
i = i + 1
GOTO 45
46 basalgn(j) = i - 1
IF j = 2 GOTO 48
j = j + 1
GOTO 44
48 CLOSE 1
RETURN

5000 REM get letter image data
SCREEN 12
GOSUB 5010
OPEN "i", 1, "galdata\letters.dat"
FOR z = 1 TO 44
INPUT #1, t$
FOR a = 1 TO 5
INPUT #1, lrow$(a)
NEXT a
REM cls
COLOR 15: GOSUB 5005
GET (1, 1)-(l, 5), letimage(1, z)
COLOR 0: GOSUB 5005
NEXT z
CLOSE
SCREEN 0
RETURN
5005 FOR a = 1 TO 5
length(z) = LEN(lrow$(a)) - 2
l = length(z)
FOR b = 1 TO l
IF MID$(lrow$(a), b + 1, 1) = "*" THEN PSET (b, a)
NEXT b
NEXT a
RETURN

5010 REM loading data message
CLS : COLOR 14: LOCATE 8, 3
PRINT "Loading Data..."
RETURN

5100 REM subroutine: print word
y = y - 4
l = LEN(word$)
IF l = 0 THEN RETURN
FOR a = -1 TO 5
   LINE (x - 1, y + a)-(x + l * 6 - 1, y + a), 0
NEXT a
xunder = x: yunder = y + 6
word$ = UCASE$(word$)
FOR a = 1 TO l
let$ = MID$(word$, a, 1)
REM convert let$ to letnum
SELECT CASE ASC(let$)
   CASE IS > 64
        letnum = ASC(let$) - 64
   CASE 48 TO 57
        letnum = ASC(let$) - 21
   CASE 32
        letnum = 39
   CASE 39
        letnum = 38
   CASE 43
        letnum = 40
   CASE 45
        letnum = 37
   CASE 46
        letnum = 42
   CASE 58
        letnum = 41
   CASE 33
        letnum = 43
   CASE 63
        letnum = 44
END SELECT
IF x <= 635 AND y <= 479 THEN
   PUT (x, y), letimage(1, letnum), PSET
END IF
x = x + length(letnum) + 1
NEXT a
REM underline if hi pop world
hipop = FNnumber(MID$(world$(ref), 24, 1))
IF hipop >= 9 AND l > 1 AND nonworld = 0 THEN
   LINE (xunder, yunder)-(x - 2, yunder), 15
END IF
RETURN

5200 REM calculate video stuff
xmost = 640
ymost = 500
REM screen aspect ratio
REM scar = 2.4
scar = (3 / 4) * (xmost / ymost)
REM hex radii
hexa = 25
hexb = INT((hexa ^ 2 - (.5 * hexa) ^ 2) ^ .5)
REM corrected for aspect ratio
chexa = hexa * scar
chexb = hexb
REM yank right
yank = xmost - INT(chexa * 1.5 * 8.3333) - 22
zi = 1
zj = 1
RETURN

5450 REM read in galaxy's uwp codes
OPEN "r", 1, galdir$ + "\uwp.dat"
exist = LOF(1)
CLOSE 1
IF exist = 0 THEN
   SHELL "copy galdata\uwp.dat " + galdir$ + "\uwp.dat"
END IF
OPEN "i", 1, galdir$ + "\uwp.dat"
t$ = ""
a = 0: b = 0
DO UNTIL EOF(1)
   LINE INPUT #1, t$
   IF LTRIM$(t$) <> "" AND LEFT$(t$, 1) <> "#" THEN
      c = INSTR(t$, "=")
      IF c = 0 THEN
         IF a > 0 THEN uwpnum%(a) = b
         a = a + 1: b = 0
         uwpstat$(a) = t$
      END IF
      IF LEFT$(t$, 4) = "pos=" THEN
         uwppos%(a, 1) = VAL(MID$(t$, 5, 2))
         IF LEN(t$) > 6 THEN
            uwppos%(a, 2) = VAL(MID$(t$, 8, 2))
         ELSE
            uwppos%(a, 2) = 0
         END IF
         IF LEN(t$) > 9 THEN
            uwppos%(a, 3) = VAL(MID$(t$, 11, 2))
         ELSE
            uwppos%(a, 3) = 0
         END IF
      END IF
      IF c <> 0 AND LEFT$(t$, 4) <> "pos=" THEN
         b = b + 1
         tmp$ = RTRIM$(LTRIM$(LEFT$(t$, c - 1)))
         IF LEN(tmp$) < 3 THEN
            uwpval%(a, b, 1) = FNnumber(tmp$)
            uwpval%(a, b, 2) = uwpval%(a, b, 1)
         ELSE
            uwpval%(a, b, 1) = FNnumber(LEFT$(tmp$, 1))
            uwpval%(a, b, 2) = FNnumber(RIGHT$(tmp$, 1))
         END IF
         uwpdef$(a, b) = RTRIM$(LTRIM$(RIGHT$(t$, LEN(t$) - c)))
      END IF
   END IF
LOOP
uwpnum%(a) = b
numstats = a
CLOSE 1
5460 REM read in sector's uwp amendments
REM check if file exists
IF nosector = 1 THEN RETURN
OPEN "r", 1, dir$ + "uwp.dat"
exist = LOF(1)
CLOSE 1
IF exist = 0 THEN SHELL "erase " + dir$ + "uwp.dat"
IF exist = 0 THEN RETURN
OPEN "i", 1, dir$ + "uwp.dat"
t$ = ""
first = 1
DO UNTIL EOF(1)
   LINE INPUT #1, t$
   IF LTRIM$(t$) <> "" AND LEFT$(t$, 1) <> "#" THEN
      c = INSTR(t$, "=")
      IF c = 0 THEN
         IF first = 0 THEN uwpnum%(a) = b
         IF first = 1 THEN first = 0
         a = 0
         FOR b1 = 1 TO numstats
            IF t$ = uwpstat$(b1) THEN a = b1
         NEXT b1
         IF a = 0 THEN
            CLS
            PRINT "Error: ";
            PRINT t$; " not defined in "; galdir$ + "\uwp.dat"
            END
         END IF
         b = uwpnum%(a)
      END IF
      IF c <> 0 THEN
         b = b + 1
         tmp$ = RTRIM$(LTRIM$(LEFT$(t$, c - 1)))
         IF LEN(tmp$) < 3 THEN
            uwpval%(a, b, 1) = FNnumber(tmp$)
            uwpval%(a, b, 2) = uwpval%(a, b, 1)
         ELSE
            uwpval%(a, b, 1) = FNnumber(LEFT$(tmp$, 1))
            uwpval%(a, b, 2) = FNnumber(RIGHT$(tmp$, 1))
         END IF
         uwpdef$(a, b) = RTRIM$(LTRIM$(RIGHT$(t$, LEN(t$) - c)))
      END IF
   END IF
LOOP
uwpnum%(a) = b
CLOSE 1
RETURN

5500 REM egacolor gold on blue
COLOR 7: CLS : PRINT "."
SHELL "egacolor 00 10"
SHELL "egacolor 07 46"
RETURN

5550 REM read 15 colors
OPEN "i", 1, "colors.cmd"
LINE INPUT #1, tmp$
FOR a = 1 TO 15
   LINE INPUT #1, tmp$
   colors$(a) = RIGHT$(tmp$, LEN(tmp$) - 4)
NEXT a
CLOSE 1
RETURN

5600 REM mini-menu #1 (attach file/menu query)
COLOR 14
LOCATE 5, 20
PRINT CHR$(218); STRING$(38, 196); CHR$(191)
FOR tmp = 6 TO 14
LOCATE tmp, 20
PRINT CHR$(179); STRING$(38, 32); CHR$(179)
NEXT tmp
LOCATE 15, 20
PRINT CHR$(192); STRING$(38, 196); CHR$(217)
COLOR 11
LOCATE 7, 22
PRINT "There is no file or menu currently"
LOCATE 8, 22
PRINT "attached to this "; tmp$; ". Your"
LOCATE 9, 22
PRINT "options are:"
COLOR 10
LOCATE 11, 27
PRINT "(F) Attach a File"
LOCATE 12, 27
PRINT "(M) Attach a Menu"
LOCATE 13, 27
PRINT "(Q) Get Me Outta Here"
RETURN

5620 REM mini-menu #2 (delete star query)
COLOR 14
LOCATE 5, 17
PRINT CHR$(218); STRING$(44, 196); CHR$(191)
FOR tmp = 6 TO 12
LOCATE tmp, 17
PRINT CHR$(179); STRING$(44, 32); CHR$(179)
NEXT tmp
LOCATE 13, 17
PRINT CHR$(192); STRING$(44, 196); CHR$(217)
COLOR 11
LOCATE 7, 21
PRINT "Are you sure you really want to delete"
LOCATE 8, 21
PRINT "this place?"
COLOR 10
LOCATE 10, 19
PRINT "(Y) Ya dang right I do! I hate those guys!"
LOCATE 11, 19
PRINT "(N) Nah, we'll have pity on the poor sots."
RETURN

5640 REM mini-menu #3 (sector's uwp.dat query)
COLOR 14
LOCATE 5, 17
PRINT CHR$(218); STRING$(44, 196); CHR$(191)
FOR tmp = 6 TO 12
LOCATE tmp, 17
PRINT CHR$(179); STRING$(44, 32); CHR$(179)
NEXT tmp
LOCATE 13, 17
PRINT CHR$(192); STRING$(44, 196); CHR$(217)
COLOR 11
LOCATE 7, 21
PRINT "This sector has no uwp.dat file. Would"
LOCATE 8, 21
PRINT "you like me to copy the one from the"
LOCATE 9, 21
PRINT "classic\beyond directory?"
COLOR 10: LOCATE 11, 29
PRINT "(Y) Yep     (N) Nope"
RETURN

5650 REM mini-menu #4 (jumproute color query)
COLOR 14: LOCATE 3, 17
PRINT CHR$(218); STRING$(44, 196); CHR$(191)
FOR tmp = 4 TO 22
LOCATE tmp, 17
PRINT CHR$(179); STRING$(44, 32); CHR$(179)
NEXT tmp
LOCATE 23, 17
PRINT CHR$(192); STRING$(44, 196); CHR$(217)
COLOR 11: LOCATE 5, 21
PRINT "Choose a color for the jumproute:"
FOR tmp = 1 TO 15
LOCATE tmp + 6, 21: COLOR tmp
PRINT "("; CHR$(64 + tmp); ") "; colors$(tmp)
NEXT tmp
RETURN

5700 REM read in settings
OPEN "i", 1, "gal.cfg"
INPUT #1, t$: l = LEN(t$)
editor$ = RIGHT$(t$, l - 7)
INPUT #1, t$: l = LEN(t$)
reader$ = RIGHT$(t$, l - 7)
INPUT #1, t$: l = LEN(t$)
galdir$ = RIGHT$(t$, l - 7)
l = LEN(galdir$)
OPEN "i", 2, "gal.lst"
INPUT #2, t$
INPUT #2, t$
DO UNTIL EOF(2)
   INPUT #2, t$
   t$ = RTRIM$(t$)
   IF t$ = "" GOTO 5705
   IF LEFT$(t$, l + 1) = galdir$ + " " THEN
      l = LEN(t$)
      galname$ = RIGHT$(t$, l - 13)
   END IF
5705 LOOP
CLOSE 2
INPUT #1, t$: l = LEN(t$)
dir$ = RTRIM$(LTRIM$(RIGHT$(t$, l - 7)))
nosector = 0
IF dir$ = "" THEN nosector = 1
5710 REM read in sector particulars
dir0$ = dir$
secdir$ = galdir$ + "\" + dir$
dir$ = secdir$ + "\"
mapdir$ = dir$ + "map\"
locdir$ = dir$ + "loc\"
gendir$ = dir$ + "gen\"
hexdir$ = dir$ + "hex\"
sysdir$ = dir$ + "sys\"
secfile$ = dir0$ + ".dat"
CLOSE 1
GOSUB 5450
l = LEN(dir0$)
IF nosector = 0 THEN
 OPEN "i", 1, galdir$ + "\" + galdir$ + ".lst"
 INPUT #1, t$
 INPUT #1, t$
 DO UNTIL EOF(1)
    INPUT #1, t$
    t$ = RTRIM$(t$)
    IF t$ <> "" THEN
       IF LEFT$(t$, l + 1) = dir0$ + " " THEN
          l = LEN(t$)
          secname2$ = RIGHT$(t$, l - 13)
       END IF
    END IF
 LOOP
 CLOSE 1
END IF
RETURN

5800 REM hooks
OPEN "i", 1, "galdata\galhooks.dat"
DO UNTIL EOF(1)
 LINE INPUT #1, t$
 t$ = RTRIM$(t$)
 IF t$ = "" GOTO 5810
 IF LEFT$(t$, 1) = "#" GOTO 5810
 l = LEN(t$)
 IF t$ = "Text Sector Map:" THEN
    a = 1: nhook%(1) = 0
 END IF
 IF t$ = "Subsector Map:" THEN
    a = 2: nhook%(2) = 0
 END IF
 IF t$ = "Text Sector Map:" OR t$ = "Subsector Map:" GOTO 5810
 nhook%(a) = nhook%(a) + 1
 IF MID$(t$, 10, 1) = "E" THEN hooke%(a, nhook%(a)) = 1
 IF MID$(t$, 10, 1) = "-" THEN hooke%(a, nhook%(a)) = 0
 hookac%(a, nhook%(a)) = VAL(MID$(t$, 11, 3))
 IF l > 59 THEN
    hookcom$(a, nhook%(a)) = RTRIM$(MID$(t$, 15, 45))
 ELSE
    hookcom$(a, nhook%(a)) = RTRIM$(RIGHT$(t$, l - 14))
 END IF
 IF l > 64 THEN
    hookspec$(a, nhook%(a)) = RTRIM$(MID$(t$, 60, 5))
 ELSEIF l > 59 AND l <= 64 THEN
    hookspec$(a, nhook%(a)) = RTRIM$(RIGHT$(t$, l - 59))
 ELSEIF l <= 59 THEN
    hookspec$(a, nhook%(a)) = ""
 END IF
5810 LOOP
CLOSE 1
RETURN

9900 REM error
COLOR 7: CLS
PRINT "Error #"; LTRIM$(STR$(ERR)); " detected around line ";
PRINT LTRIM$(STR$(ERL)); ". Now Exiting Galactic."
PRINT
PRINT "Please report this error to jimv@empirenet.com"
PRINT "Let me know where it occured so I can examine the"
PRINT "code and see if there's a bug that needs squashing."
PRINT
PRINT "For the latest patches to this software, see my"
PRINT "homepage at http://www.cs.ucr.edu/~jimv, and for"
PRINT "the latest information about Galactic, join our"
PRINT "mailing list (see galhelp\gml\signon.txt)."
PRINT
END

REM data
DATA "<reader>","<editor>","<galdir>","<secdir>"
DATA "<secfilepath>","<subfilepath>","<sublet>","<coord>"

10000 REM end
COLOR 7
CLS
PRINT
PRINT "For Assistance and/or Snide Remarks:"
PRINT
PRINT "     Email:  jimv@empirenet.com"
PRINT "             jimv@cs.ucr.edu"
PRINT "             jimv@silver.lcs.mit.edu"
PRINT "             jimv@wizards.com"
PRINT
PRINT "  Homepage:  http://www.cs.ucr.edu/~jimv"
PRINT
END

